"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants;
(function (constants) {
    let headers;
    (function (headers) {
        let request;
        (function (request) {
            // standard forwarded for header
            request.X_FORWARDED_FOR = 'X-Forwarded-For';
            // standard forwarded proto header
            request.X_FORWARDED_PROTO = 'X-Forwarded-Proto';
            // standard forwarded port header
            request.X_FORWARDED_PORT = 'X-Forwarded-Port';
            // specifies the original timeout from client side
            request.NODESWORK_FORWARDED_CLIENT_TIMEOUT = 'Nodeswork-Forwarded-Client-Timeout';
            // specifies the target for routing layer
            request.NODESWORK_FORWARDED_TO = 'Nodeswork-Forwarded-To';
        })(request = headers.request || (headers.request = {}));
    })(headers = constants.headers || (constants.headers = {}));
    (function (headers) {
        let response;
        (function (response) {
            // standard server header
            response.SERVER = 'SERVER';
            // indicate the response is generated by which applet or which product
            response.NODESWORK_PRODUCER = 'Nodeswork-Producer';
            // indicate the response is generated by which particular host
            response.NODESWORK_PRODUCER_HOST = 'Nodeswork-Producer-Host';
            // indicate the producing time
            response.NODESWORK_PRODUCER_DURATION = 'Nodeswork-Producer-Duration';
        })(response = headers.response || (headers.response = {}));
    })(headers = constants.headers || (constants.headers = {}));
})(constants = exports.constants || (exports.constants = {}));

//# sourceMappingURL=constants.js.map
