"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const params_1 = require("./params");
const sourceMetadataKey = Symbol('source');
function params(...args) {
    let resolver = params_1.filters.parse.apply(null, arguments);
    return function (target, propertyKey, paramIndex) {
        let methodResolver = Reflect.getOwnMetadata(sourceMetadataKey, target, propertyKey) || [];
        methodResolver[paramIndex] = resolver;
        Reflect.defineMetadata(sourceMetadataKey, methodResolver, target, propertyKey);
    };
}
exports.params = params;
function bind(met, options = {}) {
    return function (target, propertyName, descriptor) {
        let methodResolver = Reflect.getOwnMetadata(sourceMetadataKey, target, propertyName) || [];
        let origMethod = descriptor.value;
        let newMethod = async function (ctx, next) {
            if (ctx != null && ctx.request != null && ctx.response != null) {
                let args = [];
                for (let idx = 0; idx < methodResolver.length; idx++) {
                    args[idx] = await methodResolver[idx](ctx, ctx);
                }
                let obj = await origMethod.apply(this, args);
                ctx.body = obj;
                if (options.triggerNext && next) {
                    await next();
                }
                return obj;
            }
            else {
                return await origMethod.apply(this, arguments);
            }
        };
        newMethod.method = met;
        descriptor.value = newMethod;
    };
}
exports.bind = bind;

//# sourceMappingURL=annotation.js.map
