"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dotty = require('dotty');
function overrides(...rules) {
    const rs = [];
    for (const rule of rules) {
        const [os, od] = rule.split('->');
        if (!od) {
            throw new Error(`Rule ${rule} is not correct`);
        }
        rs.push({ src: os.split('.'), dst: od.split('.') });
    }
    return async (ctx, next) => {
        for (const { src, dst } of rs) {
            const value = dotty.get(ctx, src);
            if (value !== undefined) {
                dotty.put(ctx.overrides, dst, value);
            }
        }
        await next();
    };
}
exports.overrides = overrides;
function clearOverrides() {
    return async (ctx, next) => {
        ctx.overrides = {};
        await next();
    };
}
exports.clearOverrides = clearOverrides;

//# sourceMappingURL=middlewares.js.map
