/// <reference types="mongoose" />
/// <reference types="koa-router" />
import Router = require('koa-router');
import { ModelPopulateOptions } from 'mongoose';
import { NModelType } from '../mongoose/nmodel';
export declare class NRouter extends Router {
    nModel<T extends NModelType>(model: T, options: KoaNModelOptions): NRouter;
}
export declare function bindModel<T extends NModelType>(router: Router, model: T, options: KoaNModelOptions): Router;
export interface KoaNModelOptions {
    vPrefix?: string;
    prefix?: string;
    field: string;
    nullable?: boolean;
    level?: string;
    project?: string[];
    populate?: ModelPopulateOptions | ModelPopulateOptions[];
    omits?: string[];
    transform?: (a: any) => Promise<any>;
    allowCreateFromParentModel?: boolean;
    middlewares?: {
        [name: string]: MiddlwareValue;
    };
    use?: Router.IMiddleware | Router.IMiddleware[];
    postUse?: Router.IMiddleware | Router.IMiddleware[];
    cruds?: {
        create?: boolean | KoaNModelCreateOptions;
        get?: boolean | KoaNModelGetOptions;
        find?: boolean | KoaNModelFindOptions;
        update?: boolean | KoaNModelUpdateOptions;
        delete?: boolean | KoaNModelDeleteOptions;
    };
    methods?: {
        [name: string]: boolean | KoaNModelMethodOptions;
    };
    statics?: {
        [name: string]: boolean | KoaNModelMethodOptions;
    };
}
export interface KoaNModelMethodOptions {
    use?: Router.IMiddleware | Router.IMiddleware[];
    postUse?: Router.IMiddleware | Router.IMiddleware[];
}
export interface KoaNModelCreateOptions extends KoaNModelMethodOptions {
}
export interface KoaNModelGetOptions extends KoaNModelMethodOptions {
}
export interface KoaNModelFindOptions extends KoaNModelMethodOptions {
}
export interface KoaNModelUpdateOptions extends KoaNModelMethodOptions {
}
export interface KoaNModelDeleteOptions extends KoaNModelMethodOptions {
}
export declare type SingleMiddleware = Router.IMiddleware | object;
export declare type ListMiddleware = SingleMiddleware[];
export declare type MiddlwareValue = SingleMiddleware | ListMiddleware | ListMiddleware[];
