/// <reference types="koa-router" />
/// <reference types="mongoose" />
import { IMiddleware } from 'koa-router';
import { ModelPopulateOptions } from 'mongoose';
import * as model from './model';
export declare const READONLY = "READONLY";
export declare const AUTOGEN = "AUTOGEN";
export declare type KoaMiddlewaresType = typeof KoaMiddlewares;
export declare class KoaMiddlewares extends model.Model {
    static createMiddleware(options: CreateOptions): IMiddleware;
    static getMiddleware(options: GetOptions): IMiddleware;
    static findMiddleware(options: FindOptions): IMiddleware;
    static updateMiddleware(options: UpdateOptions): IMiddleware;
    static deleteMiddleware(options: DeleteOptions): IMiddleware;
}
export interface CommonOptions {
    noBody?: boolean;
    triggerNext?: boolean;
    target?: string;
    transform?: (a: any) => Promise<any>;
}
export interface CommonResponseOptions {
    level?: string;
    project?: string[];
    populate?: ModelPopulateOptions | ModelPopulateOptions[];
}
export interface CommonReadOptions {
}
export interface CommonWriteOptions {
    omits?: string[];
}
export interface CreateOptions extends CommonOptions, CommonResponseOptions, CommonWriteOptions {
    allowCreateFromParentModel?: boolean;
}
export interface GetOptions extends CommonOptions, CommonResponseOptions, CommonReadOptions {
    field: string;
    nullable?: boolean;
}
export interface FindOptions extends CommonOptions, CommonResponseOptions, CommonReadOptions {
    pagination?: {
        size?: number;
        sizeChoices?: number[];
    };
}
export interface UpdateOptions extends CommonOptions, CommonResponseOptions, CommonWriteOptions {
    field: string;
    nullable?: boolean;
}
export interface DeleteOptions extends CommonOptions {
    field: string;
    nullable?: boolean;
}
export declare type INext = () => Promise<any>;
