"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const model = require("./model");
class SoftDeleteModel extends model.Model {
    async delete() {
        if (this.deleted) {
            return this;
        }
        this.deleted = true;
        return await this.save();
    }
}
SoftDeleteModel.$SCHEMA = {
    deleted: {
        type: Boolean,
        default: false,
    },
};
exports.SoftDeleteModel = SoftDeleteModel;
SoftDeleteModel.Pre({
    name: 'remove',
    fn: blockRemove,
});
for (let name of model.preQueries) {
    SoftDeleteModel.Pre({ name, fn: patchDelete });
}
function patchDelete() {
    if (this._conditions == null) {
        this._conditions = {};
    }
    if (this._conditions.deleted === undefined && !this.options.withDeleted) {
        this._conditions.deleted = false;
    }
}
function blockRemove(next) {
    next(new Error('remove is not supported, use delete instead'));
}

//# sourceMappingURL=soft-delete.js.map
