"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const model = require("./model");
class TimestampModel extends model.Model {
}
TimestampModel.$SCHEMA = {
    createdAt: {
        type: Date,
        default: Date.now,
        index: true,
    },
    lastUpdateTime: {
        type: Date,
        index: true,
    },
};
exports.TimestampModel = TimestampModel;
TimestampModel.Pre({
    name: 'save',
    fn: setLastUpdateTimeOnSave,
});
TimestampModel.Pre({
    name: 'findOneAndUpdate',
    fn: setLastUpdateTimeOnUpdate,
});
function setLastUpdateTimeOnSave(next) {
    this.lastUpdateTime = Date.now();
    next();
}
function setLastUpdateTimeOnUpdate(next) {
    this.update({}, {
        '$set': {
            lastUpdateTime: Date.now(),
        },
        '$setOnInsert': {
            createdAt: Date.now(),
        }
    });
    next();
}

//# sourceMappingURL=timestamp.js.map
