/// <reference types="socket.io" />
/// <reference types="lru-cache" />
import * as LRU from 'lru-cache';
import '@nodeswork/utils/dist/promise';
export declare class SocketRpcClient {
    socket: SocketIO.Socket;
    timeoutMillis: number;
    requestEventName: string;
    responseEventName: string;
    private $cache;
    private $requsetId;
    constructor(socket: SocketIO.Socket);
    call(name: string, args: any[], timeoutMillis: number): Promise<{}>;
}
export declare function remote(options?: {
    timeoutMillis?: number;
}): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => void;
export declare function socketRpcClient(options?: {
    timeoutMillis?: number;
    eventNamePrefix?: string;
}): <T extends new (...args: any[]) => {}>(constructor: T) => {
    new (...args: any[]): {
        timeoutMillis: number;
        requestEventName: string;
        responseEventName: string;
        socket: SocketIO.Socket;
        $cache: LRU.Cache<number, ((res?: any) => void)[]>;
        ___: SocketIO.Socket;
    };
} & T;
